diff -r f40675df5d4c trytond/modules/account/move.py
--- a/trytond/modules/account/move.py	Fri Sep 21 15:57:18 2012 +0200
+++ b/trytond/modules/account/move.py	Mon Sep 24 20:36:38 2012 +0200
@@ -1243,48 +1209,48 @@
                     attrs.append('required="0"')
                 xml += ('<field name="%s" %s/>\n'
                     % (column.field.name, ' '.join(attrs)))
-                for depend in getattr(self, column.field.name).depends:
+                for depend in getattr(cls, column.field.name).depends:
                     fields.add(depend)
             fields.add('state')
             xml += '</tree>'
             result['arch'] = xml
-            result['fields'] = self.fields_get(fields_names=list(fields))
+            result['fields'] = cls.fields_get(fields_names=list(fields))
         return result
 
-    def reconcile(self, ids, journal_id=None, date=None, account_id=None):
+    @classmethod
+    def reconcile(cls, lines, journal=None, date=None, account=None):
         pool = Pool()
-        move_obj = pool.get('account.move')
-        currency_obj = pool.get('currency.currency')
-        reconciliation_obj = pool.get('account.move.reconciliation')
-        period_obj = pool.get('account.period')
-        date_obj = pool.get('ir.date')
-        translation_obj = pool.get('ir.translation')
+        Move = pool.get('account.move')
+        Reconciliation = pool.get('account.move.reconciliation')
+        Period = pool.get('account.period')
+        Date = pool.get('ir.date')
+        Translation = pool.get('ir.translation')
 
-        for line in self.browse(ids):
+        for line in lines:
             if line.reconciliation:
-                self.raise_user_error('already_reconciled',
+                cls.raise_user_error('already_reconciled',
                         error_args=(line.name, line.id,))
 
-        ids = ids[:]
-        if journal_id and account_id:
+        lines = lines[:]
+        if journal and account:
             if not date:
-                date = date_obj.today()
+                date = Date.today()
             account = None
             amount = Decimal('0.0')
-            for line in self.browse(ids):
+            for line in lines:
                 amount += line.debit - line.credit
                 if not account:
                     account = line.account
-            amount = currency_obj.round(account.currency, amount)
-            period_id = period_obj.find(account.company.id, date=date)
+            amount = account.currency.round(amount)
+            period_id = Period.find(account.company.id, date=date)
             lang_code = CONFIG['language']
             if account.company.lang:
                 lang_code = account.company.lang.code
-            writeoff = translation_obj.get_source(
+            writeoff = Translation.get_source(
                     'account.move.reconcile_lines.writeoff', 'view', lang_code,
                     'Write-Off') or 'Write-Off'
-            move_id = move_obj.create({
-                'journal': journal_id,
+            move = Move.create({
+                'journal': journal.id,
                 'period': period_id,
                 'date': date,
                 'lines': [
@@ -1298,7 +1264,7 @@
                     }),
                     ('create', {
                         'name': writeoff,
-                        'account': account_id,
+                        'account': account.id,
                         'debit': amount > Decimal('0.0') and amount \
                                 or Decimal('0.0'),
                         'credit': amount < Decimal('0.0') and - amount \
@@ -1306,33 +1272,28 @@
                     }),
                 ],
                 })
-            ids += self.search([
-                ('move', '=', move_id),
+            lines += cls.search([
+                ('move', '=', move.id),
                 ('account', '=', account.id),
                 ('debit', '=', amount < Decimal('0.0') and - amount \
                         or Decimal('0.0')),
                 ('credit', '=', amount > Decimal('0.0') and amount \
                         or Decimal('0.0')),
                 ], limit=1)
-        return reconciliation_obj.create({
-            'lines': [('add', x) for x in ids],
-            })
+        return Reconciliation.create({
+                'lines': [('add', [x.id for x in lines])],
+                })
 
-Line()
 
-
-class Move2(ModelSQL, ModelView):
-    _name = 'account.move'
+class Move2:
+    __name__ = 'account.move'
     centralised_line = fields.Many2One('account.move.line', 'Centralised Line',
             readonly=True)
 
-Move2()
-
 
 class OpenJournalAsk(ModelView):
     'Open Journal Ask'
-    _name = 'account.move.open_journal.ask'
-    _description = __doc__
+    __name__ = 'account.move.open_journal.ask'
     journal = fields.Many2One('account.journal', 'Journal', required=True)
     period = fields.Many2One('account.period', 'Period', required=True,
         domain=[
@@ -1341,18 +1302,16 @@
                 Eval('context', {}).get('company', 0)),
             ])
 
-    def default_period(self):
-        period_obj = Pool().get('account.period')
-        return period_obj.find(Transaction().context.get('company'),
+    @staticmethod
+    def default_period():
+        Period = Pool().get('account.period')
+        return Period.find(Transaction().context.get('company'),
                 exception=False)
 
-OpenJournalAsk()
-
 
 class OpenJournal(Wizard):
     'Open Journal'
-    _name = 'account.move.open_journal'
-
+    __name__ = 'account.move.open_journal'
     start = StateTransition()
     ask = StateView('account.move.open_journal.ask',
         'account.open_journal_ask_view_form', [
@@ -1361,99 +1320,85 @@
             ])
     open_ = StateAction('account.act_move_line_form')
 
-    def transition_start(self, session):
+    def transition_start(self):
         if (Transaction().context.get('active_model', '')
                 == 'account.journal.period'
                 and Transaction().context.get('active_id')):
             return 'open_'
         return 'ask'
 
-    def default_ask(self, session, fields):
-        journal_period_obj = Pool().get('account.journal.period')
+    def default_ask(self, fields):
+        JournalPeriod = Pool().get('account.journal.period')
         if (Transaction().context.get('active_model', '') ==
                 'account.journal.period'
                 and Transaction().context.get('active_id')):
-            journal_period = \
-                journal_period_obj.browse(Transaction().context['active_id'])
+            journal_period = JournalPeriod(Transaction().context['active_id'])
             return {
                 'journal': journal_period.journal.id,
                 'period': journal_period.period.id,
-            }
+                }
         return {}
 
-    def do_open_(self, session, action):
-        pool = Pool()
-        journal_period_obj = pool.get('account.journal.period')
-        journal_obj = pool.get('account.journal')
-        period_obj = pool.get('account.period')
+    def do_open_(self, action):
+        JournalPeriod = Pool().get('account.journal.period')
 
         if (Transaction().context.get('active_model', '') ==
                 'account.journal.period'
                 and Transaction().context.get('active_id')):
-            journal_period = \
-                journal_period_obj.browse(Transaction().context['active_id'])
-            journal_id = journal_period.journal.id
-            period_id = journal_period.period.id
+            journal_period = JournalPeriod(Transaction().context['active_id'])
+            journal = journal_period.journal
+            period = journal_period.period
         else:
-            journal_id = session.ask.journal.id
-            period_id = session.ask.period.id
-        journal_period_ids = journal_period_obj.search([
-            ('journal', '=', journal_id),
-            ('period', '=', period_id),
-            ])
-        if not journal_period_ids:
-            journal = journal_obj.browse(journal_id)
-            period = period_obj.browse(period_id)
-            journal_period_id = journal_period_obj.create({
+            journal = self.ask.journal
+            period = self.ask.period
+        journal_periods = JournalPeriod.search([
+                ('journal', '=', journal.id),
+                ('period', '=', period.id),
+                ], limit=1)
+        if not journal_periods:
+            journal_period = JournalPeriod.create({
                     'name': journal.name + ' - ' + period.name,
                     'journal': journal.id,
                     'period': period.id,
                     })
         else:
-            journal_period_id = journal_period_ids[0]
-        journal_period = journal_period_obj.browse(journal_period_id)
+            journal_period, = journal_periods
 
         action['name'] += ' - %s' % journal_period.rec_name
         action['pyson_domain'] = PYSONEncoder().encode([
-            ('journal', '=', journal_id),
-            ('period', '=', period_id),
+            ('journal', '=', journal.id),
+            ('period', '=', period.id),
             ])
         action['pyson_context'] = PYSONEncoder().encode({
-            'journal': journal_id,
-            'period': period_id,
+            'journal': journal.id,
+            'period': period.id,
             })
         return action, {}
 
-    def transition_open_(self, session):
+    def transition_open_(self):
         return 'end'
 
-OpenJournal()
-
 
 class OpenAccount(Wizard):
     'Open Account'
-    _name = 'account.move.open_account'
+    __name__ = 'account.move.open_account'
     start_state = 'open_'
     open_ = StateAction('account.act_move_line_form')
 
-    def do_open_(self, session, action):
-        pool = Pool()
-        fiscalyear_obj = pool.get('account.fiscalyear')
+    def do_open_(self, action):
+        FiscalYear = Pool().get('account.fiscalyear')
 
         if not Transaction().context.get('fiscalyear'):
-            fiscalyear_ids = fiscalyear_obj.search([
-                ('state', '=', 'open'),
-                ])
+            fiscalyears = FiscalYear.search([
+                    ('state', '=', 'open'),
+                    ])
         else:
-            fiscalyear_ids = [Transaction().context['fiscalyear']]
+            fiscalyears = [FiscalYear(Transaction().context['fiscalyear'])]
 
-        period_ids = []
-        for fiscalyear in fiscalyear_obj.browse(fiscalyear_ids):
-            for period in fiscalyear.periods:
-                period_ids.append(period.id)
+        periods = [p for f in fiscalyears for p in f.periods]
 
         action['pyson_domain'] = [
-            ('period', 'in', period_ids),
+            ('period', 'in', [p.id for p in periods]),
             ('account', '=', Transaction().context['active_id']),
             ]
         if Transaction().context.get('posted'):
@@ -1467,29 +1412,24 @@
         })
         return action, {}
 
-OpenAccount()
-
 
 class ReconcileLinesWriteOff(ModelView):
     'Reconcile Lines Write-Off'
-    _name = 'account.move.reconcile_lines.writeoff'
-    _description = __doc__
+    __name__ = 'account.move.reconcile_lines.writeoff'
     journal = fields.Many2One('account.journal', 'Journal', required=True)
     date = fields.Date('Date', required=True)
     account = fields.Many2One('account.account', 'Account', required=True,
             domain=[('kind', '!=', 'view')])
 
-    def default_date(self):
-        date_obj = Pool().get('ir.date')
-        return date_obj.today()
-
-ReconcileLinesWriteOff()
+    @staticmethod
+    def default_date():
+        Date = Pool().get('ir.date')
+        return Date.today()
 
 
 class ReconcileLines(Wizard):
     'Reconcile Lines'
-    _name = 'account.move.reconcile_lines'
-
+    __name__ = 'account.move.reconcile_lines'
     start = StateTransition()
     writeoff = StateView('account.move.reconcile_lines.writeoff',
         'account.reconcile_lines_writeoff_view_form', [
@@ -1498,84 +1438,71 @@
             ])
     reconcile = StateTransition()
 
-    def transition_start(self, session):
-        line_obj = Pool().get('account.move.line')
-        currency_obj = Pool().get('currency.currency')
+    def transition_start(self):
+        Line = Pool().get('account.move.line')
 
         company = None
         amount = Decimal('0.0')
-        for line in line_obj.browse(Transaction().context['active_ids']):
+        for line in Line.browse(Transaction().context['active_ids']):
             amount += line.debit - line.credit
             if not company:
                 company = line.account.company
         if not company:
             return 'end'
-        if currency_obj.is_zero(company.currency, amount):
+        if company.currency.is_zero(amount):
             return 'reconcile'
         return 'writeoff'
 
-    def transition_reconcile(self, session):
-        line_obj = Pool().get('account.move.line')
+    def transition_reconcile(self):
+        Line = Pool().get('account.move.line')
 
-        journal_id = None
+        journal = None
         date = None
-        account_id = None
-        if session.writeoff.journal:
-            journal_id = session.writeoff.journal.id
-        if session.writeoff.date:
-            date = session.writeoff.date
-        if session.writeoff.account:
-            account_id = session.writeoff.account.id
-        line_obj.reconcile(Transaction().context['active_ids'], journal_id,
-            date, account_id)
+        account = None
+        if self.writeoff.journal:
+            journal = self.writeoff.journal
+        if self.writeoff.date:
+            date = self.writeoff.date
+        if self.writeoff.account:
+            account = self.writeoff.account
+        Line.reconcile(Line.browse(Transaction().context['active_ids']),
+            journal, date, account)
         return 'end'
 
-ReconcileLines()
-
 
 class UnreconcileLinesStart(ModelView):
     'Unreconcile Lines'
-    _name = 'account.move.unreconcile_lines.start'
-    _description = __doc__
-
-UnreconcileLinesStart()
+    __name__ = 'account.move.unreconcile_lines.start'
 
 
 class UnreconcileLines(Wizard):
     'Unreconcile Lines'
-    _name = 'account.move.unreconcile_lines'
+    __name__ = 'account.move.unreconcile_lines'
     start_state = 'unreconcile'
-
     unreconcile = StateTransition()
 
-    def transition_unreconcile(self, session):
-        line_obj = Pool().get('account.move.line')
-        reconciliation_obj = Pool().get('account.move.reconciliation')
+    def transition_unreconcile(self):
+        pool = Pool()
+        Line = pool.get('account.move.line')
+        Reconciliation = pool.get('account.move.reconciliation')
 
-        lines = line_obj.browse(Transaction().context['active_ids'])
-        reconciliation_ids = [x.reconciliation.id for x in lines \
-                if x.reconciliation]
-        if reconciliation_ids:
-            reconciliation_obj.delete(reconciliation_ids)
+        lines = Line.browse(Transaction().context['active_ids'])
+        reconciliations = [x.reconciliation for x in lines if x.reconciliation]
+        if reconciliations:
+            Reconciliation.delete(reconciliations)
         return 'end'
 
-UnreconcileLines()
-
 
 class OpenReconcileLinesStart(ModelView):
     'Open Reconcile Lines'
-    _name = 'account.move.open_reconcile_lines.start'
-    _description = __doc__
+    __name__ = 'account.move.open_reconcile_lines.start'
     account = fields.Many2One('account.account', 'Account', required=True,
             domain=[('kind', '!=', 'view'), ('reconcile', '=', True)])
 
-OpenReconcileLinesStart()
-
 
 class OpenReconcileLines(Wizard):
     'Open Reconcile Lines'
-    _name = 'account.move.open_reconcile_lines'
-
+    __name__ = 'account.move.open_reconcile_lines'
     start = StateView('account.move.open_reconcile_lines.start',
         'account.open_reconcile_lines_start_view_form', [
             Button('Cancel', 'end', 'tryton-cancel'),
@@ -1583,67 +1510,60 @@
             ])
     open_ = StateAction('account.act_move_line_form')
 
-    def do_open_(self, session, action):
+    def do_open_(self, action):
         action['pyson_domain'] = PYSONEncoder().encode([
-            ('account', '=', session.start.account.id),
+            ('account', '=', self.start.account.id),
             ('reconciliation', '=', None),
             ])
         return action, {}
 
-OpenReconcileLines()
-
 
 class FiscalYearLine(ModelSQL):
     'Fiscal Year - Move Line'
-    _name = 'account.fiscalyear-account.move.line'
+    __name__ = 'account.fiscalyear-account.move.line'
     _table = 'account_fiscalyear_line_rel'
-    _description = __doc__
     fiscalyear = fields.Many2One('account.fiscalyear', 'Fiscal Year',
             ondelete='CASCADE', select=True)
     line = fields.Many2One('account.move.line', 'Line', ondelete='RESTRICT',
             select=True, required=True)
 
-FiscalYearLine()
 
-
-class FiscalYear(ModelSQL, ModelView):
-    _name = 'account.fiscalyear'
+class FiscalYear2:
+    __name__ = 'account.fiscalyear'
     close_lines = fields.Many2Many('account.fiscalyear-account.move.line',
             'fiscalyear', 'line', 'Close Lines')
 
-FiscalYear()
-
 
 class PrintGeneralJournalStart(ModelView):
     'Print General Journal'
-    _name = 'account.move.print_general_journal.start'
-    _description = __doc__
+    __name__ = 'account.move.print_general_journal.start'
     from_date = fields.Date('From Date', required=True)
     to_date = fields.Date('To Date', required=True)
     company = fields.Many2One('company.company', 'Company', required=True)
     posted = fields.Boolean('Posted Move', help='Show only posted move')
 
-    def default_from_date(self):
-        date_obj = Pool().get('ir.date')
-        return datetime.date(date_obj.today().year, 1, 1)
+    @staticmethod
+    def default_from_date():
+        Date = Pool().get('ir.date')
+        return datetime.date(Date.today().year, 1, 1)
 
-    def default_to_date(self):
-        date_obj = Pool().get('ir.date')
-        return date_obj.today()
+    @staticmethod
+    def default_to_date():
+        Date = Pool().get('ir.date')
+        return Date.today()
 
-    def default_company(self):
+    @staticmethod
+    def default_company():
         return Transaction().context.get('company')
 
-    def default_posted(self):
+    @staticmethod
+    def default_posted():
         return False
 
-PrintGeneralJournalStart()
-
 
 class PrintGeneralJournal(Wizard):
     'Print General Journal'
-    _name = 'account.move.print_general_journal'
-
+    __name__ = 'account.move.print_general_journal'
     start = StateView('account.move.print_general_journal.start',
         'account.print_general_journal_start_view_form', [
             Button('Cancel', 'end', 'tryton-cancel'),
@@ -1651,23 +1571,22 @@
             ])
     print_ = StateAction('account.report_general_journal')
 
-    def do_print_(self, session, action):
+    def do_print_(self, action):
         data = {
-            'company': session.start.company.id,
-            'from_date': session.start.from_date,
-            'to_date': session.start.to_date,
-            'posted': session.start.posted,
+            'company': self.start.company.id,
+            'from_date': self.start.from_date,
+            'to_date': self.start.to_date,
+            'posted': self.start.posted,
             }
         return action, data
 
-PrintGeneralJournal()
-
 
 class GeneralJournal(Report):
-    _name = 'account.move.general_journal'
+    __name__ = 'account.move.general_journal'
 
-    def _get_objects(self, ids, model, data):
-        move_obj = Pool().get('account.move')
+    @classmethod
+    def _get_records(cls, ids, model, data):
+        Move = Pool().get('account.move')
 
         clause = [
             ('date', '>=', data['from_date']),
@@ -1675,21 +1594,19 @@
             ]
         if data['posted']:
             clause.append(('state', '=', 'posted'))
-        move_ids = move_obj.search(clause,
+        return Move.search(clause,
                 order=[('date', 'ASC'), ('reference', 'ASC'), ('id', 'ASC')])
-        return move_obj.browse(move_ids)
 
-    def parse(self, report, objects, data, localcontext):
-        company_obj = Pool().get('company.company')
+    @classmethod
+    def parse(cls, report, moves, data, localcontext):
+        Company = Pool().get('company.company')
 
-        company = company_obj.browse(data['company'])
+        company = Company(data['company'])
 
         localcontext['company'] = company
         localcontext['digits'] = company.currency.digits
         localcontext['from_date'] = data['from_date']
         localcontext['to_date'] = data['to_date']
 
-        return super(GeneralJournal, self).parse(report, objects, data,
+        return super(GeneralJournal, cls).parse(report, moves, data,
             localcontext)
-
-GeneralJournal()
diff -r f40675df5d4c trytond/modules/account/party.py
--- a/trytond/modules/account/party.py	Fri Sep 21 15:57:18 2012 +0200
+++ b/trytond/modules/account/party.py	Mon Sep 24 20:36:38 2012 +0200
@@ -1,14 +1,17 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
 from decimal import Decimal
-from trytond.model import ModelView, ModelSQL, fields
+from trytond.model import fields
 from trytond.pyson import Eval, Bool
 from trytond.transaction import Transaction
-from trytond.pool import Pool
+from trytond.pool import Pool, PoolMeta
 
+__all__ = ['Party']
+__metaclass__ = PoolMeta
 
-class Party(ModelSQL, ModelView):
-    _name = 'party.party'
+
+class Party:
+    __name__ = 'party.party'
     account_payable = fields.Property(fields.Many2One('account.account',
             'Account Payable', domain=[
                 ('kind', '=', 'payable'),
@@ -48,40 +51,33 @@
     payable_today = fields.Function(fields.Numeric('Payable Today'),
             'get_receivable_payable', searcher='search_receivable_payable')
 
-    def get_receivable_payable(self, ids, names):
+    @classmethod
+    def get_receivable_payable(cls, parties, names):
         '''
         Function to compute receivable, payable (today or not) for party ids.
-
-        :param ids: the ids of the party
-        :param names: the list of field name to compute
-        :return: a dictionary with all field names as key and
-            a dictionary as value with id as key
         '''
         res = {}
         pool = Pool()
-        move_line_obj = pool.get('account.move.line')
-        user_obj = pool.get('res.user')
-        date_obj = pool.get('ir.date')
+        MoveLine = pool.get('account.move.line')
+        User = pool.get('res.user')
+        Date = pool.get('ir.date')
         cursor = Transaction().cursor
 
         for name in names:
             if name not in ('receivable', 'payable',
                     'receivable_today', 'payable_today'):
                 raise Exception('Bad argument')
-            res[name] = dict((x, Decimal('0.0')) for x in ids)
-
-        if not ids:
-            return {}
+            res[name] = dict((p.id, Decimal('0.0')) for p in parties)
 
         user_id = Transaction().user
         if user_id == 0 and 'user' in Transaction().context:
             user_id = Transaction().context['user']
-        user = user_obj.browse(user_id)
+        user = User(user_id)
         company_id = user.company.id
         if not company_id:
             return res
 
-        line_query, _ = move_line_obj.query_get()
+        line_query, _ = MoveLine.query_get()
 
         for name in names:
             code = name
@@ -91,7 +87,7 @@
                 code = name[:-6]
                 today_query = 'AND (l.maturity_date <= %s ' \
                         'OR l.maturity_date IS NULL) '
-                today_value = [date_obj.today()]
+                today_value = [Date.today()]
 
             cursor.execute('SELECT l.party, '
                     'SUM((COALESCE(l.debit, 0) - COALESCE(l.credit, 0))) '
@@ -100,13 +96,13 @@
                     'AND a.active '
                     'AND a.kind = %s '
                     'AND l.party IN '
-                        '(' + ','.join(('%s',) * len(ids)) + ') '
+                        '(' + ','.join(('%s',) * len(parties)) + ') '
                     'AND l.reconciliation IS NULL '
                     'AND ' + line_query + ' '
                     + today_query +
                     'AND a.company = %s '
                 'GROUP BY l.party',
-                [code] + ids + today_value + [company_id])
+                [code] + [p.id for p in parties] + today_value + [company_id])
             for party_id, sum in cursor.fetchall():
                 # SQLite uses float for SUM
                 if not isinstance(sum, Decimal):
@@ -114,12 +110,13 @@
                 res[name][party_id] = sum
         return res
 
-    def search_receivable_payable(self, name, clause):
+    @classmethod
+    def search_receivable_payable(cls, name, clause):
         pool = Pool()
-        move_line_obj = pool.get('account.move.line')
-        company_obj = pool.get('company.company')
-        user_obj = pool.get('res.user')
-        date_obj = pool.get('ir.date')
+        MoveLine = pool.get('account.move.line')
+        Company = pool.get('company.company')
+        User = pool.get('res.user')
+        Date = pool.get('ir.date')
         cursor = Transaction().cursor
 
         if name not in ('receivable', 'payable',
@@ -130,12 +127,12 @@
         user_id = Transaction().user
         if user_id == 0 and 'user' in Transaction().context:
             user_id = Transaction().context['user']
-        user = user_obj.browse(user_id)
+        user = User(user_id)
         if Transaction().context.get('company'):
-            child_company_ids = company_obj.search([
-                ('parent', 'child_of', [user.main_company.id]),
-                ])
-            if Transaction().context['company'] in child_company_ids:
+            child_companies = Company.search([
+                    ('parent', 'child_of', [user.main_company.id]),
+                    ])
+            if Transaction().context['company'] in child_companies:
                 company_id = Transaction().context['company']
 
         if not company_id:
@@ -151,9 +148,9 @@
             code = name[:-6]
             today_query = 'AND (l.maturity_date <= %s ' \
                     'OR l.maturity_date IS NULL) '
-            today_value = [date_obj.today()]
+            today_value = [Date.today()]
 
-        line_query, _ = move_line_obj.query_get()
+        line_query, _ = MoveLine.query_get()
 
         cursor.execute('SELECT l.party '
             'FROM account_move_line AS l, account_account AS a '
@@ -170,5 +167,3 @@
                 + clause[1] + ' %s)',
             [code] + today_value + [company_id] + [Decimal(clause[2] or 0)])
         return [('id', 'in', [x[0] for x in cursor.fetchall()])]
-
-Party()
